#Include "Protheus.ch"
#INCLUDE "Ap5Mail.ch"
#INCLUDE "rwmake.ch"
#INCLUDE "topconn.ch" 

#DEFINE USADO CHR(0)+CHR(0)+CHR(1)
#DEFINE ENTER CHR(13)+CHR(10)
/*


ͻ
Programa  AMDPCP01  Autor  Kanam L. R. Rdorigues Data 13/08/12   
͹
Desc.      Realiza o ajuste de empenho e transferncia de armazm     
           Filtrado pela OP.                                          
͹
Uso                                                                   
ͼ


*/
*----------------------*
User Function AMDPCP01()
*----------------------*
Local   bOk     := {||lOk:=.T.,If(ValidCpo(),oDlg:End(),)}
Local   bCancel := {||lOk:=.F.       ,oDlg:End()}
Local   lOk     := .F.
Local   nLin    := 20
Local   nCol1   := 15
Local   nCol2   := nCol1+30
Local   oArq
Local   oDlg
Private i       := 1
Private cOP     := AvKey("","D4_OP")
Private cArmOri := "50"
Private cArmDes := "60"
Private cTitulo := 'Ajuste de Empenhos'
Private cFilSB2 := xFilial("SB2")
Private cFilSD4 := xFilial("SD4")

SB1->(dbSetOrder(1))
SB2->(dbSetOrder(1))
SC2->(dbSetOrder(1))
SD3->(dbSetOrder(2))
SD4->(dbSetOrder(2))

Define MsDialog oDlg Title cTitulo From 7,10 To 15,50 OF oMainWnd         
   *   
   @ nLin,nCol1  Say      'Num. OP.:'                                                                Of oDlg Pixel  
   @ nLin,nCol2  MsGet    oOP   Var cOP Valid (!Vazio() .And. ExistCpo("SC2"))  F3 "SC2"  Size 60,09 Of oDlg Pixel  
   *
Activate MsDialog oDlg On Init Enchoicebar(oDlg,bOk,bCancel) Centered      

If lOk
   AjustaEmp()
EndIf   
//
Return                    

/*
Funcao      : ValidCpo
Objetivos   : Valida o dado digitado na OP
Autor       : Kanam L. R. Rodrigues 
Data/Hora   : 13/08/2012
*/
*------------------------*
Static Function ValidCpo()
*------------------------*
Local lRet   := .T.
Local nDecs  := TamSX3("C2_QUANT")[2]
Local nSalOP := NoRound(0, nDecs) // Forar valor zero com casa decimais do SX3


If Empty(cOP)
   MsgInfo("Preencha o n da OP.")
   lRet := .F.
ElseIf !SC2->(dbSeek(xFilial("SC2")+cOP))
   MsgInfo("OP informada no existe.")
   lRet := .F.
ElseIf Len(cOp) != 13
   MsgInfo("Digite o n completo da OP.")
   lRet := .F.
Else
   SC2->(dbSeek(xFilial("SC2")+cOP))
   If SC2->C2_DATRF == STOD("")
      nSalOP := Max(0,NoRound(SC2->(C2_QUANT - C2_QUJE - C2_PERDA), nDecs))
   EndIf
   If nSalOP <= 0
      MsgInfo("OP selecionada no possui saldo ou j foi encerrada.")
      lRet := .F.
   EndIf
EndIf

Return lRet              

/*
Funcao      : AjustaEmp
Objetivos   : Tela de ajustes de empenhos
Autor       : Kanam L. R. Rodrigues 
Data/Hora   : 13/08/2012
*/
*-------------------------*
Static Function AjustaEmp()
*-------------------------*
Local   oDlg
Local   aPos       := {}
Local   bOk        := {||lOk := .T.,If(GravaDados(),oDlg:End(),)}
Local   bCancel    := {||lOk := .F.,oDlg:End()}
Local   lOk        := .F.
Private oEnc    
Private oGetDados
Private aHeader    := {}
Private aCols      := {}
Private aColsAux   := {}
Private aAlter     := {}
Private cDocumento := GetSxENum("SD3","D3_DOC",cFilAnt+"SD3"+cEmpAnt+"0",2)
Private dA261Data  := dDataBase
Private aQtX       := {}
//variveis utilizadas na validao padro dos campos
Private l380 := .F., l381 := .T., Altera := .T., lZeraEmp := .F.
Private nPosQuant  := 6, nPosQtdOri := 5, nPosCod := 1, nPosSegUM := 12


//carrega dados filtrados no aCols para exibio.
BuscaDados("SD4")
If Len(aCols)==0
   MsgInfo("No foram encontrados registros para a OP selecionada!"+ENTER+;
           "Verifique se o material j foi transferido!")
   Return
EndIf
//tela de ajuste de empen
oMainWnd:ReadClientCoors()  
Define MsDialog oDlg Title cTitulo FROM 0, 0 To oMainWnd:nBottom-35, oMainWnd:nRight-20 Of oMainWnd Pixel
   *
   aPos      := PosDlg(oDlg)
   oGetDados := MsNewGetDados():New(aPos[1],aPos[2],aPos[3],aPos[4],GD_UPDATE,,,,aAlter,,,"U_VALCPEMP()",;
                                    ,,oDlg,aHeader,aCols)
   *       
Activate MsDialog oDlg On Init Enchoicebar(oDlg,bOk,bCancel) Centered      
//
Return


/*
Funcao      : GravaDados
Objetivos   : Abre tela de transferncia e em seguida Grava dados de empenho e transferncia 
Autor       : Kanam L. R. Rodrigues 
Data/Hora   : 13/08/2012
*/
*--------------------------*
Static Function GravaDados()
*--------------------------*
Local   lRet     := .T.
Private aHeader2 := {}//aHeader da transferncia
Private aCols2   := {}//aCols da transferncia

Begin Transaction
   aCols := aClone(aColsAux)
   If TransArm()
      For i:= 1 To Len(aCols)
         //dbSeek para garantir que est posicionado no registro certo.
         SD4->(dbSeek(cFilSD4+cOP+aCols[i][nPosCod]))
         RecLock("SD4",.F.)
         SD4->D4_QUANT   := aCols[i][nPosQuant]
         SD4->D4_QTDEORI := aCols[i][nPosQtdOri]
         SD4->D4_QT_X_OR := aQtX[i][1]
         SD4->D4_QT_X_SA := aQtX[i][2]
         SD4->D4_X_DOC   := cDocumento
         SD4->(MsUnlock())
         //acerta quantidade empenhada no armazem de destino.
         SB2->(dbSeek(cFilSB2+aCols[i][nPosCod]+cArmDes))
         RecLock("SB2",.F.)
         SB2->B2_QEMP += (aCols[i][7]*(-1))
         SB2->(MsUnlock())
      Next i
      If !GrvTrans()
         lRet := .F.
         RollBackSx8()
         DisarmTransaction()
      Else
         If Verif()
            ConfirmSx8()
            MsgInfo("Movimentao realizada com sucesso!")
            cSql := "UPDATE "+ RetSqlName('SD4') + " SET D4_OP = '"+cOp+"'  WHERE D_E_L_E_T_ <> '*' AND D4_FILIAL = '"+xFilial("SD4")+"' AND D4_DOC = '"+cDocumento+"'"
            TCSQLExec(cSql)
         Else
            MsgAlert("Ocorreu um prolema durante o processamento!"+ENTER+;
                     "Favor refazer o processamento")
            DisarmTransaction()
         EndIf
      EndIf
   Else
      lRet := .F.
      RollBackSx8()
      DisarmTransaction()
   EndIf
End Transaction
//
Return lRet


/*
Funcao      : BuscaDados
Objetivos   : Busca dados necessrios e j cria aHeader e aCols 
Autor       : Kanam L. R. Rodrigues 
Data/Hora   : 13/08/2012
*/
*--------------------------------*
Static Function BuscaDados(cAlias)
*--------------------------------*   
Local cQry   := ""
Local aCpoD4 := {"D4_COD","D4_LOCAL","D4_OP",;
                 "D4_DATA","D4_QTDEORI","D4_QUANT",;
                 "D4_TRT","D4_LOTECTL","D4_NUMLOTE",;
                 "D4_DTVALID","D4_QTSEGUM","D4_POTENCI"}

If cAlias == "SD4"
   //DEFINIO DO AHEADERS
   SX3->(dbSetOrder(1))
   SX3->(dbSeek(cAlias))
   While !SX3->(Eof()) .AND. SX3->X3_ARQUIVO == cAlias
      If X3Uso(SX3->X3_USADO) .AND. cNivel >= SX3->X3_NIVEL .AND.;
         (aScan(aCpoD4,{|x| x==AllTrim(SX3->X3_CAMPO)})>0)
         If SX3->X3_CAMPO != "D4_QUANT"
            aAdd(aHeader,{Trim(X3Titulo()),;
                           SX3->X3_CAMPO,;
                           SX3->X3_PICTURE,;
                           SX3->X3_TAMANHO,;
                           SX3->X3_DECIMAL,;
                           SX3->X3_VALID,;
                           "",;
                           SX3->X3_TIPO,;
                           "",;
                           ""})
         Else
            aAdd(aHeader,{Trim(X3Titulo()),;
                           SX3->X3_CAMPO,;
                           SX3->X3_PICTURE,;
                           SX3->X3_TAMANHO,;
                           SX3->X3_DECIMAL,;
                           "U_ValD4Qnt()",;
                           "",;
                           SX3->X3_TIPO,;
                           "",;
                           ""})
            aAdd(aHeader,{Trim("Diferena"),;
                           "DIFERE",;
                           SX3->X3_PICTURE,;
                           SX3->X3_TAMANHO,;
                           SX3->X3_DECIMAL,;
                           "",;
                           "",;
                           SX3->X3_TIPO,;
                           "",;
                           ""})
         EndIf
      EndIf
      SX3->(dbSkip())
   EndDo

   //ADICIONA CAMPOS QUE PODERO SER ALTERADOS
   aAdd(aAlter, "D4_QUANT")

   //CRIA ACOLS COM OS DADOS RETORNADOS DA QUERY
   cQry += "SELECT SD4.D_E_L_E_T_, SD4.D4_FILIAL, SD4.D4_OP, SD4.D4_COD, "
   cQry += "       SD4.D4_LOCAL, SD4.D4_DATA, SD4.D4_QTDEORI, SD4.D4_QUANT, "
   cQry += "       SD4.D4_TRT, SD4.D4_LOTECTL, SD4.D4_NUMLOTE, "
   cQry += "       SD4.D4_DTVALID, SD4.D4_QTSEGUM, SD4.D4_POTENCI "
   cQry += "FROM "+RetSqlName("SD4")+" SD4 "
   cQry += "WHERE SD4.D_E_L_E_T_ <> '*' AND "
   cQry += "      SD4.D4_FILIAL = '"+xFilial("SD4")+"' AND "          
   cQry += "      SD4.D4_OP = '"+cOP+"' AND "
   cQry += "      SD4.D4_X_DOC = '' "
   cQry += "ORDER BY SD4.D4_OP, SD4.D4_COD"
   PlsQuery(cQry, "TRB")

   TRB->(dbGoTop())
   While TRB->(!Eof())
      aAdd(aCols,{TRB->D4_COD,;
                  TRB->D4_LOCAL,;
                  TRB->D4_OP,;
                  TRB->D4_DATA,;
                  TRB->D4_QTDEORI,;
                  TRB->D4_QUANT,;
                  TRB->(D4_QTDEORI-D4_QUANT),;
                  TRB->D4_TRT,;
                  TRB->D4_LOTECTL,;
                  TRB->D4_NUMLOTE,;
                  TRB->D4_DTVALID,;
                  TRB->D4_QTSEGUM,;
                  TRB->D4_POTENCI,;
                  .F.})
      aAdd(aQtx, {TRB->D4_QTDEORI,;
                  TRB->D4_QUANT})
      TRB->(dbSkip())
   EndDo
   TRB->(dbCloseArea())

   aColsAux := aClone(aCols)
Else
   aTam := TamSX3('D3_COD'    ); Aadd(aHeader2, {"Prod.Orig."      , 'D3_COD'    , PesqPict('SD3', 'D3_COD'    , aTam[1]         ),	aTam[1], aTam[2], 'A261VldCod(1)'                    , USADO, 'C', 'SD3', ''}) // 'Prod.Orig.'
   aTam := TamSX3('D3_DESCRI' ); Aadd(aHeader2, {"Desc.Orig."      , 'D3_DESCRI' , PesqPict('SD3', 'D3_DESCRI' , aTam[1]         ),	aTam[1], aTam[2], ''                                 , USADO, 'C', 'SD3', ''}) // 'Desc.Orig.'
   aTam := TamSX3('D3_UM'     ); Aadd(aHeader2, {"UM Orig."        , 'D3_UM'     , PesqPict('SD3', 'D3_UM'     , aTam[1], aTam[1]),	aTam[1], aTam[2], ''	                             , USADO, 'C', 'SD3', ''}) // 'UM Orig.'
   aTam := TamSX3('D3_LOCAL'  ); Aadd(aHeader2, {"Armazem Orig."   , 'D3_LOCAL'  , PesqPict('SD3', 'D3_LOCAL'  , aTam[1]         ),	aTam[1], aTam[2], 'A261Almox(1)'                   	 , USADO, 'C', 'SD3', ''}) // 'Almox Orig.'
   aTam := TamSX3('D3_LOCAL'  ); Aadd(aHeader2, {"Armazem Destino" , 'D3_LOCAL'  , PesqPict('SD3', 'D3_LOCAL'  , aTam[1]         ), aTam[1], aTam[2], 'A261Almox(2)'                  	 , USADO, 'C', 'SD3', ''}) // 'Almox Destino'
   aTam := TamSX3('D3_QUANT'  ); Aadd(aHeader2, {"Quantidade"      , 'D3_QUANT'  , PesqPict('SD3', 'D3_QUANT'  ,  			     ), aTam[1], aTam[2], 'A261QtdGra(1).and.A261Quant(.T.)' , USADO, 'N', 'SD3', ''}) // 'Quantidade'
   aTam := TamSX3('D3_LOCALIZ'); Aadd(aHeader2, {"Endereco Orig."  , 'D3_LOCALIZ', PesqPict('SD3', 'D3_LOCALIZ', aTam[1]         ), aTam[1], aTam[2], 'A261Locali(1)'                    , USADO, 'C', 'SD3', ''}) // 'Localiz.Orig.'
   aTam := TamSX3('D3_COD'    ); Aadd(aHeader2, {"Prod.Destino"    , 'D3_COD'    , PesqPict('SD3', 'D3_COD'    , aTam[1]         ),	aTam[1], aTam[2], 'A261VldCod(2)'                 	 , USADO, 'C', 'SD3', ''}) // 'Prod.Destino'
   aTam := TamSX3('D3_DESCRI' ); Aadd(aHeader2, {"Desc.Destino"    , 'D3_DESCRI' , PesqPict('SD3', 'D3_DESCRI' , aTam[1]         ),	aTam[1], aTam[2], ''                              	 , USADO, 'C', 'SD3', ''}) // 'Desc.Destino'
   aTam := TamSX3('D3_UM'     ); Aadd(aHeader2, {"UM Destino"      , 'D3_UM'     , PesqPict('SD3', 'D3_UM'     , aTam[1], aTam[1]),	aTam[1], aTam[2], ''           	                 	 , USADO, 'C', 'SD3', ''}) // 'UM Destino'
   aTam := TamSX3('D3_LOCALIZ'); Aadd(aHeader2, {"Endereco Destino", 'D3_LOCALIZ', PesqPict('SD3', 'D3_LOCALIZ', aTam[1]         ), aTam[1], aTam[2], 'A261Locali(2)'                    , USADO, 'C', 'SD3', ''}) // 'Localiz.Destino'
   aTam := TamSX3('D3_NUMSERI'); Aadd(aHeader2, {"Numero Serie"    , 'D3_NUMSERI', PesqPict('SD3', 'D3_NUMSERI', aTam[1]         ), aTam[1], aTam[2], ''                                 , USADO, 'C', 'SD3', ''}) // 'Nmero Serie'
   aTam := TamSX3('D3_LOTECTL'); Aadd(aHeader2, {"Lote"            , 'D3_LOTECTL', PesqPict('SD3', 'D3_LOTECTL', aTam[1]         ), aTam[1], aTam[2], 'A261Lote()'                       , USADO, 'C', 'SD3', ''}) // 'Lote'
   aTam := TamSX3('D3_NUMLOTE'); Aadd(aHeader2, {"Sub-Lote"        , 'D3_NUMLOTE', PesqPict('SD3', 'D3_NUMLOTE', aTam[1]         ), aTam[1], aTam[2], 'A261Lote()'                       , USADO, 'C', 'SD3', ''}) // 'Sub-Lote'
   aTam := TamSX3('D3_DTVALID'); Aadd(aHeader2, {"Validade"        , 'D3_DTVALID', PesqPict('SD3', 'D3_DTVALID', aTam[1]         ), aTam[1], aTam[2], ''                                 , USADO, 'D', 'SD3', ''}) // 'Validade'
   aTam := TamSX3('D3_POTENCI'); Aadd(aHeader2, {"Potencia"        , 'D3_POTENCI', PesqPict('SD3', 'D3_POTENCI', aTam[1]         ), aTam[1], aTam[2], ''                                 , USADO, 'N', 'SD3', ''}) // 'Potencia'
   aTam := TamSX3('D3_QTSEGUM'); Aadd(aHeader2, {"Qt 2aUM"         , 'D3_QTSEGUM', PesqPict('SD3', 'D3_QTSEGUM',         		 ), aTam[1], aTam[2], 'A261QtdGra(1).and.A261Quant(.T.)' , USADO, 'N', 'SD3', ''}) // 'Qt 2aUM'
   aTam := TamSX3('D3_ESTORNO'); Aadd(aHeader2, {"Estornado"       , 'D3_ESTORNO', PesqPict('SD3', 'D3_ESTORNO', aTam[1]         ), aTam[1], aTam[2], ''                                 , USADO, 'C', 'SD3', ''}) // 'Estornado'
   aTam := TamSX3('D3_NUMSEQ' ); Aadd(aHeader2, {"Sequencia"       , 'D3_NUMSEQ' , PesqPict('SD3', 'D3_NUMSEQ' , aTam[1]         ), aTam[1], aTam[2], ''                                 , USADO, 'C', 'SD3', ''}) // 'Sequencia'
   aTam := TamSX3('D3_LOTECTL'); Aadd(aHeader2, {"Lote Destino"    , 'D3_LOTECTL', PesqPict('SD3', 'D3_LOTECTL', aTam[1]         ), aTam[1], aTam[2], ''                                 , USADO, 'C', 'SD3', ''})
   aTam := TamSX3('D3_DTVALID'); Aadd(aHeader2, {"Validade Destino", 'D3_DTVALID', PesqPict('SD3', 'D3_DTVALID', aTam[1]         ), aTam[1], aTam[2], 'A261DtPot(3)'                     , USADO, 'D', 'SD3', ''}) // 'Validade Destino'
   aTam := TamSX3('D3_ITEMGRD'); Aadd(aHeader2, {"Item Grade"      , 'D3_ITEMGRD', PesqPict('SD3', 'D3_ITEMGRD', aTam[1]         ), aTam[1], aTam[2], ''                                 , USADO, 'C', 'SD3', ''}) // 'Sequencia'

   For i:=1 To Len(aCols)
      SB1->(dbSeek(xFilial("SB1")+AvKey(aCols[i][nPosCod],"B1_COD")))
      aAdd(aCols2, {aCols[i][nPosCod],;  //Prod Origem
                    SB1->B1_DESC,;       //Descrio
                    SB1->B1_UM,;         //Unid Medida
                    cArmOri,;            //Armazem origem
                    cArmDes,;            //Armazm destino
                    aCols[i][nPosQuant],;//Quantidade
                    "",;                 //End. Origem
                    aCols[i][nPosCod],;  //Prod Dest.
                    SB1->B1_DESC,;       //Descrio
                    SB1->B1_UM,;         //Unid Medida
                    "",;                 //End. Dest.
                    "",;                 //Num. Serie
                    "",;                 //Lote
                    "",;                 //Sub-Lote
                    STOD(""),;           //Validade
                    0,;                  //Potencia
                    0,;                  //Qtde 2 UM
                    "",;                 //Estornado
                    "",;                 //Seq.
                    "",;                 //Lote Dest.
                    STOD(""),;           //Valid Dest.
                    "",;                 //Item Grade
                    .F.})                //Delete
   Next i                   
EndIf
//
Return


/*
Funcao      : TransArm
Objetivos   : Realiza a transferncia de armazns
Autor       : Kanam L. R. Rodrigues 
Data/Hora   : 13/08/2012
*/
*------------------------*
Static Function TransArm()
*------------------------*
Local lRet := .T.
Local oDlg
Local oGDTrans
Local bOk := {|| oDlg:End()}
Local bCancel := {||lRet:=.F.,oDlg:End()}
//variveis utilizadas na rotina de validao
Private l261 := .F., l250 := .F., l241 := .F., l240 := .F.

//
BuscaDados("SD3")
//
oMainWnd:ReadClientCoors()  
Define MsDialog oDlg Title cTitulo FROM 0, 0 To oMainWnd:nBottom-35, oMainWnd:nRight-20 Of oMainWnd Pixel

   @ 1.5, 00.5	SAY   OemToAnsi("Nmero Documento")
   @ 1.5, 08.0 MSGET cDocumento Picture PesqPict('SD3','D3_DOC') Valid VldDoc()  SIZE 65,08 OF oDlg
   @ 1.5, 18.0 SAY   OemToAnsi("Emisso")
   @ 1.5, 21.0 MSGET dA261Data  Picture "@D"                                     SIZE 65,08 OF oDlg
   aPos     := PosDlg(oDlg)
   oGDTrans := MsNewGetDados():New(aPos[1]+15,aPos[2],aPos[3],aPos[4],GD_UPDATE,,,,{},,,,;
                                    ,,oDlg,aHeader2,aCols2)
   *       
Activate MsDialog oDlg On Init Enchoicebar(oDlg,bOk,bCancel) Centered      

Return lRet

/*
Funcao      : ValCpEmp
Objetivos   : Utilizada para alterar aCols
Autor       : Kanam L. R. Rodrigues 
Data/Hora   : 13/08/2012
*/
*----------------------*
User Function ValCpEmp()
*----------------------*

aColsAux[n][nPosQtdOri] := M->D4_QUANT
aColsAux[n][nPosQuant]  := M->D4_QUANT
aColsAux[n][7]          := aQtX[n][1]-M->D4_QUANT

Return .T.


/*
Funcao      : GrvTrans
Objetivos   : Realiza o ExecAuto da rotina de transf de materiais
Autor       : Kanam L. R. Rodrigues 
Data/Hora   : 13/08/2012
*/
*------------------------*
Static Function GrvTrans()
*------------------------*
Local   aAuto       := {}
Private lMsErroAuto := .F.

aAdd(aAuto,{cDocumento,dA261Data})

For i:=1 To Len(aCols2)
   aAdd(aAuto, {aCols2[i][01],;  //Prod Origem
                aCols2[i][02],;  //Descrio
                aCols2[i][03],;  //Unid Medida
                aCols2[i][04],;  //Armazem origem
                aCols2[i][07],;  //End. Origem
                aCols2[i][08],;  //Prod Dest.
                aCols2[i][09],;  //Descrio
                aCols2[i][10],;  //Unid Medida
                aCols2[i][05],;  //Armazm destino
                aCols2[i][11],;  //End. Dest.
                aCols2[i][12],;  //Num. Serie
                aCols2[i][13],;  //Lote
                aCols2[i][14],;  //Sub-Lote
                aCols2[i][15],;  //Validade
                aCols2[i][16],;  //Potencia
                aCols2[i][06],;  //Quantidade
                aCols2[i][17],;  //Qtde 2 UM
                aCols2[i][18],;  //Estornado
                aCols2[i][19],;  //Seq.
                aCols2[i][20],;  //Lote Dest.
                aCols2[i][21],;  //Valid Dest.
                aCols2[i][22]})  //Item Grade
Next i

MSExecAuto({|x,y| mata261(x,y)},aAuto,3)//incluso
If lMsErroAuto
   ConOut("Erro na inclusao!")			
   MostraErro()
EndIf
//
Return !lMsErroAuto

/*
Funcao      : ValD4Qnt
Objetivos   : Funo utilizada para gatilhar o clculo da diferena do saldo e da quantidade empenhada.
Autor       : Kanam L. R. Rodrigues 
Data/Hora   : 13/08/2012
*/
*----------------------*
User Function ValD4Qnt()
*----------------------*
//
aCols[n][nPosQtdOri] := M->D4_QUANT
aCols[n][7]          := aQtX[n][1]-M->D4_QUANT
oGetDados:ForceRefresh()
//
Return .T.

/*
Funcao      : VldDoc
Objetivos   : Validao do n do documento
Autor       : Kanam L. R. Rodrigues 
Data/Hora   : 24/09/2012
*/
*----------------------*
Static Function VldDoc()
*----------------------*
Local lRet := .T.
//
If SD3->(dbSeek(xFilial("SD3")+cDocumento))
   lRet:= .F.
   MsgAlert('N de documento j utilizado!')
EndIf
//
Return lRet

/*
Funcao      : Verif
Objetivos   : Realiza consistncia da transferncia
Autor       : Kanam L. R. Rodrigues 
Data/Hora   : 09/11/2012
*/
*-------------------*
Static Function Verif()
*-------------------*
Local lRet := .T.
Local cQry := ""

cQry := " SELECT COUNT(*) D4_TOTAL"
cQry += " FROM "+RetSqlName("SD4")+" SD4 "
cQry += " WHERE SD4.D_E_L_E_T_ <> '*' "
cQry += " AND SD4.D4_FILIAL = '"+xFilial("SD4")+"' "
cQry += " AND SD4.D4_X_DOC = '"+AllTrim(cDocumento)+"'"
PlsQuery(cQry,"TRB1")

cQry := " SELECT COUNT(*) D3_TOTAL"
cQry += " FROM "+RetSqlName("SD3")+" SD3 "
cQry += " WHERE SD3.D_E_L_E_T_ <> '*' "
cQry += " AND SD3.D3_FILIAL = '"+xFilial("SD3")+"' "
cQry += " AND SD3.D3_DOC = '"+AllTrim(cDocumento)+"'"
PlsQuery(cQry,"TRB2")

If TRB1->D4_TOTAL == 0 .OR. TRB2->D3_TOTAL == 0
   lRet := .F.
   SendMail()
EndIf

TRB1->(dbCloseArea())
TRB2->(dbCloseArea())
//
Return lRet


/*
Funcao      : SendMail
Objetivos   : Envia e-mail com o erro ocorrido
Autor       : Kanam L. R. Rodrigues 
Data/Hora   : 09/11/2012
*/
*----------------------*
Static Function SendMail()
*----------------------*
Local cHtml     := ""
Local cServidor := GetMV("MV_RELSERV")
Local cConta    := GetMV("MV_RELACNT")
Local cPassWord := GetMV("MV_RELPSW") 
Local cContEnv  := "kanaam@amend.com.br;petras@amend.com.br;nevair@amend.com.br" 
Local cAssunto  := "(PROTHEUS11) - ERRO - Transferncia de armazns OP: "+AllTrim(cOP)


CONNECT SMTP SERVER cServidor ACCOUNT cConta PASSWORD cPassWord Result lConectou
	
   cHtml  := "<table width='1036' border='0'>"
   cHtml  += "<tr>"
   cHtml  += "<td><img src='http://www2.amend.com.br/images/topPortal.jpg' width='1036' height='71'></td>"
   cHtml  += "</tr>"
   cHtml  += "<tr>"
   cHtml  += "<td align='center'>"
   cHtml  += "<br>"
   cHtml  += "<font size='2' face='Verdana, Arial, Helvetica, sans-serif'><strong>Transferncia da OP: <font color='#FF0000'>"+ Alltrim(cOP)+"</font> teve problemas.</strong></font>.<br>"
   cHtml  += "<br>"
   cHtml  += "<font size='2' face='Verdana, Arial, Helvetica, sans-serif'><strong>Documento: <font color='#FF0000'>"+ Alltrim(cDocumento)+"</font> </strong></font>.<br>"
   cHtml  += "<div align='left'><BR>"
   cHtml  += "<table width='700' border='0'>"
   cHtml  += "<tr>"
   cHtml  += "<td width='53' height='17'><strong><font size='1' face='Verdana, Arial, Helvetica, sans-serif'>DATA:</font></strong></td>"
   cHtml  += "<td width='637'><font size='1' face='Verdana, Arial, Helvetica, sans-serif'>"+Dtoc(dDataBase)+"</font></td>"
   cHtml  += "</tr>"
   cHtml  += "<tr>"
   cHtml  += "<td height='17'><strong><font size='1' face='Verdana, Arial, Helvetica, sans-serif'>HORA:</font></strong></td>"
   cHtml  += "<td><font size='1' face='Verdana, Arial, Helvetica, sans-serif'>"+Time()+"</font></td>"
   cHtml  += "</tr>"
   cHtml  += "<tr>"
   cHtml  += "<td height='17'><strong><font size='1' face='Verdana, Arial, Helvetica, sans-serif'>ROTINA:</font></strong></td>"
   cHtml  += "<td><font size='1' face='Verdana, Arial, Helvetica, sans-serif'>AMDPCP01</font></td>"
   cHtml  += "</tr>"
   cHtml  += "</table>"
   cHtml  += "</div></td>"
   cHtml  += "</tr>"
   cHtml  += "</table>"	

	
SEND MAIL From "workflow@amend.com.br" To cContEnv SUBJECT cAssunto BODY cHtml RESULT lEnvio

Return